package Entities 
{
	import net.flashpunk.Entity;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Mask;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author Mitzhawk
	 */
	public class Player extends Entity 
	{
		[Embed(source = "../../Assets/Entities/Player1.png")]private const MAGMAP:Class;
		[Embed(source = "../../Assets/Entities/Player1.png")]private const MAGBLUE:Class;
		private var myMap:Spritemap = new Spritemap(MAGMAP, 38, 32);
		private var myMapB:Spritemap = new Spritemap(MAGBLUE, 38, 32);
		private var theGraphic:Graphiclist = new Graphiclist();
		private var walkAnim:String = "s";
		private var lastMoved:String = "s";
		
		
		//movement vars
        private var jumpPower:Number=8.4;//4.3
        private var hFriction:Number=0.85;//0.85
        private var vFriction:Number=0.99;//0.99
        public var xSpeed:Number=0;
        public var ySpeed:Number=0;//its 6.2 so he jump when he appear
        private var onTheGround:Boolean=false;
        private var gravity:Number = 0.37;//0.20
		private var SpeedW:Number = 3;
		private var SpeedR:Number = 3;
		private var pressedLT:int = 0;
		private var pressedRT:int = 0;
		private var onceAir:Boolean = true;
		private var releasedJumpKey:Boolean = true;
		private var onceGoDown:Boolean = false;
		private var forceToStay:Boolean = false;//for collideing into walls
		private var groundArray:Array = ["solid"];
		private var MAX_SPEED:Number = 1;
		private var finalDist:Number = 0;
		private var timerRunDust:int = 1;
		private var showNowRPart:Boolean = true;
		private var showNowLPart:Boolean = true;
		
		//gravity vars
		private var normGravity:int = 1;
		
		//test
		public var t:Text = new Text("");
		private var t2:Text = new Text("");
		private var t3:Text = new Text("");
		
		public function Player(x:Number, y:Number) 
		{
			super(x, y);
			maps();
			graphic = theGraphic;
			theGraphic.add(myMap);
			theGraphic.add(myMapB);
			theGraphic.add(t);
			theGraphic.add(t2);
			theGraphic.add(t3);
			myMap.play(walkAnim);
			myMapB.play(walkAnim);
			myMapB.alpha = 0;
			myMap.centerOO();
			myMapB.centerOO();
			cameraFollow();
			setHitbox(32, 32, 16, 16);
			layer = -5;
			name = "player";
			
			t.color = 0xFF00FF;
			t2.color = 0xFF00FF;
			t3.color = 0xFF00FF;
		}
		private function maps():void
		{
			myMap.add("s", [0], 0, false);
			myMap.add("w", [2, 3, 2, 1], 0.11, true);
			myMap.add("j1", [4], 0, false);
			myMap.add("j2", [5], 0, false);
			
			myMapB.add("s", [0], 0, false);
			myMapB.add("w", [2, 3, 2, 1], 0.11, true);
			myMapB.add("j1", [5], 0, false);
			myMapB.add("j2", [4], 0, false);
		}
		override public function update():void
		{
			super.update();
			animations();
			
			cameraFollow();
			
			changeGrav();
			spin();
			if(myMap.angle%180==0)
			movement();
			
			//test stuff
			t.x = 10;
			t.y = 10;
			t2.x = 10;
			t2.y = 30;
			t3.x = 10;
			t3.y = 50;
			t.text = "";
			//t2.text = "vFriction: " + vFriction;
			//t3.text = "ySpeed: " + ySpeed;
			
		}
		public function animations():void
		{
			//initialise walk anim
			walkAnim = "";
			
			//where does he walks
			if (Input.check(Key.A)|| Input.check(Key.LEFT)) {
				walkAnim = "w";
				lastMoved = "l";
			}
			else{
			    if (Input.check(Key.D)|| Input.check(Key.RIGHT)) {
					walkAnim = "w";
					lastMoved = "r";
			    }
			}
			
			if (forceToStay)
			walkAnim = "s";
			
			if (ySpeed < 0) {
				walkAnim = "j1";
			}
			if (ySpeed > 0) {
				walkAnim = "j2";
			}
			
			//if he didnt moved last frame, where to look when he stay
			if (lastMoved == "r") {
				myMap.flipped = false;
				myMapB.flipped = false;
				setHitbox(32,32,17,16);
			}
			else {
				myMap.flipped = true;
				myMapB.flipped = true;
				setHitbox(32,32,16,16);
			}
			if (normGravity < 0) {
				myMap.flipped = myMapB.flipped = !myMap.flipped;
			}
			if (walkAnim == "") {
				walkAnim = "s";
			}
			
			
			//play the decided anim
			myMap.play(walkAnim);
			myMapB.play(walkAnim);
			
			if (walkAnim == "s") {
				if (Input.check(Key.W)|| Input.check(Key.UP)) {
					myMap.index = myMapB.index = 1;
				}
				else {
					if (Input.check(Key.S)|| Input.check(Key.DOWN)) {
						myMap.index = myMapB.index = 2;
						
					}
					else {
						myMap.index = myMapB.index = 0;
					}
				}
			}
			
		}
		private function cameraFollow():void
		{
			//FP.camera.x = x - FP.halfWidth;
			//FP.camera.y = y - FP.halfHeight;
		}
		private function changeGrav():void
		{
			if (Input.pressed(Key.K) && myMap.angle % 180 == 0) {
				
				normGravity *= -1;
				gravity = -gravity;
				ySpeed = 1 * normGravity;
				
				if (normGravity < 0) {
					myMap.angle = myMapB.angle = 0;
					
					myMap.alpha = 0;
					myMapB.alpha = 1;
				}
				else{
					myMap.alpha = 1;
					myMapB.alpha = 0;
					
				}
				
				myMap.angle += 18;
				myMapB.angle += 18;
			}
		}
		private function spin():void
		{
			if (myMap.angle % 180 != 0) {
				
				myMap.angle += 18;
				myMapB.angle += 18;
				
				if ((myMap.angle + 18) > 180) {
					
					if (normGravity<0) {
						myMap.angle = myMapB.angle = 180;
					}
					else {
						if (myMap.angle + 18 > 360) {
							myMap.angle = myMapB.angle = 360;
						}
					}
				}
			}
		}
		private function movement():void
		{
			//if (y > Level.mapHeight)
			//died = true;
			
			var pressed:Boolean = false;
			var jOverSmallHolles:Boolean = false;
			
			if(!myMap.flipped){
				if ((!collideTypes(["solid","solidG"], x + 2, y)) || (!collideTypes(["solid","solidG"], x + 2, y))) {
					if ((collideTypes(["solid","solidG"], x + 2, y + 1)) || (collideTypes(["solid","solidG"], x + 2, y + 1))) {
						jOverSmallHolles = true;
					}
				}
			}
			else{
				if ((!collideTypes(["solid","solidG"], x - 2, y)) || (!collideTypes(["solid","solidG"], x - 2, y))) {
					if ((collideTypes(["solid","solidG"], x - 2, y + 1)) || (collideTypes(["solid","solidG"], x - 2, y + 1))) {
						jOverSmallHolles = true;
					}
				}
			}
			
			//jump
			
			
			if (collideTypes(groundArray, x, y + 1*normGravity)) {
                onTheGround = true;
                ySpeed = 0;
				
                if ((Input.check(Key.L)|| Input.check(Key.X)) && releasedJumpKey && onceGoDown == false) {
					releasedJumpKey = false;
					if (ySpeed == 0)
                    ySpeed -= jumpPower*normGravity;
                }
            } else {
				onTheGround = false;
				
				if(normGravity>0){
					if(ySpeed<8){
						ySpeed += gravity;
					}
				}
				else {
					if(ySpeed>-8){
						ySpeed += gravity;
					}
				}
            }
			
			
			if (Input.released(Key.L) || Input.released(Key.X)) {
				releasedJumpKey = true;
			}
			
			
			if (ySpeed == 0 && (collideTypes(groundArray,x,y+1*normGravity))){
			    onTheGround = true;
				onceAir = false;
				onceGoDown = false;
			}
			
			ySpeed *= vFriction;
			
			
			//move l r
            if (Input.check(Key.A) || Input.check(Key.LEFT)) {
				xSpeed = -SpeedW;
                pressed=true;
            }
			else
            if (Input.check(Key.D) || Input.check(Key.RIGHT)) {
				xSpeed = SpeedW;
				
                pressed=true;
            }
			
            
			
			//if its running add firction
			/*
			if(runing){
			    if (Math.abs(xSpeed)<1&&! pressed) {
                    xSpeed=0;
                }
               xSpeed *= hFriction;
			}
			else {
				if (!pressed && !bumped) {
                   xSpeed=0;
                }
			}
			*/
			
			
			//force to stay if collide into wals
			forceToStayColWalls();
			
			//the types to check colision
			var collideWith:Array = ["solid","solidG"];
			
			
			moveBy(xSpeed, ySpeed, collideWith);
			xSpeed = 0;
			
			
		}
		override public function moveCollideX(e:Entity):Boolean 
		{
			xSpeed = 0;
			return true;
        }
        override public function moveCollideY(e:Entity):Boolean 
		{
			ySpeed = 0;
			
			return true;
        }
		private function forceToStayColWalls():void
		{
			forceToStay = false;
			
			if (onTheGround) {
				if (xSpeed < 0) {
					if (collideTypes(["solid","solidG"], x - 1, y)) {
						
						forceToStay = true;
						
						return;
					}
				}
				else {
					if (xSpeed > 0) {
						if (collideTypes(["solid","solidG"], x + 1, y)) {
							forceToStay = true;
							
							return;
						}
					}
				}
			}
		}
		
	}

}